/***************************************************************************
                          kmathtool.h  -  description
                             -------------------
    begin                : Mit Apr 10 19:46:42 CEST 2002
    copyright            : (C) 2002 by Birgit Schulz
    email                : B.Schulz@Superlehrer.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KMATHTOOL_H
#define KMATHTOOL_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

//KDE-Libs
#include <kapplication.h>
#include <kaction.h>
#include <kmenubar.h>
#include <kmainwindow.h>
#include <kstandarddirs.h>

//Qt-Libs
#include <qwidget.h>
 
//eigene Header
#include "kmathtoolview.h"

/** KMathTool is the base class of the project */
class KMathTool : public KMainWindow
{
  Q_OBJECT 
  public:
    /** construtor */
    KMathTool(QWidget* parent=0, const char *name=0);
    /** destructor */
    ~KMathTool();

//Menuentries of Menu Functions    
    KAction* FunctionsLinesTwoPoints;
    KAction* FunctionsLinesOnePoint;
    KAction* FunctionsLinesAxisSection;
    KAction* FunctionsLinesSection;
    
    KAction* FunctionsParabolaFindScheitel;
    KAction* FunctionsParabolaAxisSection;
    KAction* FunctionsParabolaEquationWithScheitel;
    KAction* FunctionsParabolaEquationWith3Points;
    KAction* FunctionsParabolaEquationWithScheitelAndPoint;
    KAction* FunctionsParabolaSections;
  KAction* FunctionsParabolaLineSection;
  KAction* FunctionsParabolaParabolaSection;
    
//Menuentries of Menu Calculate
    KAction* CalculateCalculateIntegerDivision;
    KAction* CalculateCalculateDevision;
    KAction* CalculateCalculateMultiplikation1;
	//    KAction* CalculateCalculateMultiplikation2;
    
    KAction* CalculateFactorsHCF;
    KAction* CalculateFactorsLCM;
    KAction* CalculateFactorsFactorize;
    KAction* CalculateFactorsFactors;
    KAction* CalculateFactorsProvePrime;
    KAction* CalculateFactorsFindPrime;


//Menuentries of Menu Geometry
    KAction* GeometryAreaSquare;
    KAction* GeometryAreaRectangle;
    KAction* GeometryAreaCircle;




    
private:
    KMathToolView *view;
    
    

  public slots:
    void slotShowLinesTwoPoints();
    
   
    

};

#endif
